var h5_currentPageIndex = 1;
var h5_sessionId;
var h5_totalPageNumber = 1;
var h5_isShowParam = true;
var h5_isDelayShowParam = false;
var h5_hasChart = false;
var h5_hasChartJSLoaded = false;
var h5_hasFineReportJSLoaded = false;
var originalPageBlockWidth = 1;
var originalWidthScale = 1;

var H5_element = {
    ID:{
        parameterPane:"wrap_form",  //参数面板
        pageContentPane:"h5_pagecontent",   //报表内容
        pageNumberPane:"pagenumber",    //页码
        sliderPane:"slider",    //滑条
        toolbarPane:"toolbar",   //工具栏
        filterButton:"filter",   //参数面板按钮
        sliderWrap:"sliderwrap" //滑条容器
    },

    changeElementsAfterLoadReport:function() {
        document.body.style.backgroundColor = "#ffffff";
    },

    changeElementsAfterShowParameterPane:function() {
        document.body.style.backgroundColor = "#f1fbff";
    },

    getParameterPane:function() {
        return document.getElementById(H5_element.ID.parameterPane);
    },

    hideParameterPane:function() {
        if(this.getParameterPane() != null) {
            this.getParameterPane().setAttribute("hidden", "true");
        }
    },

    showParameterPane:function() {
        if(this.getParameterPane() != null) {
            this.getParameterPane().removeAttribute("hidden");
        }
    },

    getPageContentPane:function() {
        return document.getElementById(H5_element.ID.pageContentPane);
    },

    removePageContentPane:function() {
        if(this.getPageContentPane() != null) {
            h5_removeDom(this.getPageContentPane());
        }
    },

    getPageNumberPane:function() {
        return document.getElementById(H5_element.ID.pageNumberPane);
    },

    setPageNumberPaneText:function(text) {
        if(this.getPageNumberPane() != null) {
            this.getPageNumberPane().innerText = h5_currentPageIndex + "/" + h5_totalPageNumber;
        }
    },

    getSliderPane:function() {
        return document.getElementById(H5_element.ID.sliderPane);
    },

    setSliderValue:function(value) {
        if(this.getSliderPane() != null) {
            this.getSliderPane().value = value;
        }
    },

    getToolbarPane:function() {
        return document.getElementById(this.ID.toolbarPane);
    },

    hideToolbarPane:function() {
        if(this.getToolbarPane() != null) {
            this.getToolbarPane().setAttribute("hidden", "true");
        }
    },

    getSliderWrap:function() {
        return document.getElementById(this.ID.sliderWrap);
    },

    hideSliderWrap:function() {
        if(this.getSliderWrap() != null) {
            this.getSliderWrap().setAttribute("hidden", "true");
        }
    },

    showSliderWrap:function() {
        if(this.getSliderWrap() != null) {
            this.getSliderWrap().removeAttribute("hidden");
        }
    }

}

function h5_removeDom(dom) {
    dom.parentNode.removeChild(dom);
}

//初始化参数面板
function h5_initPara(isShow, isDelay, sessionId, widgetNames) {
    h5_isShowParam = (isShow == "true");
    h5_isDelayShowParam = (isDelay == "true");
    var fix_page_refresh_select = document.getElementById("h5_fix_page_refresh_select");
    if(!h5_isShowParam || !h5_isDelayShowParam || (fix_page_refresh_select != null && fix_page_refresh_select.value == "change")) {
        //不显示或者延迟显示，直接查询
        submitParameters(sessionId, widgetNames);
    } else {
        H5_element.showParameterPane();
    }
}

//提交
function submitParameters(sessionid, widgetNames) {
    var self = this;
    h5_sessionId = sessionid;
    //先把参数传到后台，然后提交表单
    widgetNames = widgetNames.split(",");
    var data = "op=fr_dialog&cmd=parameters_d&sessionID=" + sessionid + "&__fit__=true&_paperWidth=" + window.innerWidth + "&_paperHeight=" + (window.innerHeight - toolbarHeight());
    data += collectValues(widgetNames);
    var xmlHttp = new XMLHttpRequest();
    xmlHttp.open("POST", FR.servletURL);
    xmlHttp.setRequestHeader("Content-Type","application/x-www-form-urlencoded");
    xmlHttp.send(data);
    xmlHttp.onreadystatechange = function() {
        if(xmlHttp.readyState === 4 && xmlHttp.status === 200) {
            //window大小发生变化时，调整报表内容大小
            $(window).resize(function () {
                if (self.timer != null) {
                    clearTimeout(self.timer);
                }
                self.timer = setTimeout(function () {
                    var widthScale = Math.min(window.innerWidth * originalWidthScale / originalPageBlockWidth, 2.0);
                    if(widthScale > 1) {
                        originalWidthScale = widthScale;
                        H5_element.getPageContentPane().style.height = (window.innerHeight - toolbarHeight()) + "px";
                        resizeFrozenSize();
                    }
                    self.lastTimer = null;
                }, 200);
            });
            loadReportOfPage(1, sessionid);
        } else {
        }
    }
    return false;
}

function resizeFrozenSize() {
    var pageContent = $(H5_element.getPageContentPane());
    var frozenPage = $(".frozen-page", pageContent);
    if(frozenPage.length > 0) {
        var $center = $('.frozen-center', frozenPage);
        var $north = $('.frozen-north', frozenPage);
        var $west = $('.frozen-west', frozenPage);
        var frozenWidth = $west.width();
        var frozenHeight = $north.height();
        $center.width(pageContent.width() - frozenWidth);
        $center.height(pageContent.height() - frozenHeight);
        $west.height(pageContent.height() - frozenHeight);
    }
}

//加载第n页报表
function loadReportOfPage(index, sessionid) {
    h5_addLoading();
    var xmlHttp = new XMLHttpRequest();
    xmlHttp.open("POST", FR.servletURL);
    xmlHttp.setRequestHeader("Content-Type","application/x-www-form-urlencoded");
    xmlHttp.send("op=page_content&sessionID=" + sessionid + "&pn=" + index);
    xmlHttp.onreadystatechange = function() {
        if(xmlHttp.readyState === 4 && xmlHttp.status === 200) {
            h5_removeLoading();
            H5_element.changeElementsAfterLoadReport();
            H5_element.removePageContentPane();
            h5_currentPageIndex = index;
            var responseText = xmlHttp.responseText;
            var pageContent = document.createElement("div");
            if(responseText.indexOf("iframe id=\"error_iframe\"") > 0) {
                //出错
                var errorDom = document.createElement("div");
                errorDom.innerText = "Error";
                pageContent.appendChild(errorDom);
            } else {
                dealWithChartResource(xmlHttp.responseText);
                pageContent.innerHTML = dealWithPageContent(xmlHttp.responseText);
                H5_element.setPageNumberPaneText(h5_currentPageIndex + "/" + h5_totalPageNumber);
                H5_element.setSliderValue(h5_currentPageIndex);
                var fix_page_refresh_select = document.getElementById("h5_fix_page_refresh_select");
                if(fix_page_refresh_select != null) {
                    fix_page_refresh_select.value = "change";
                }
            }
            var pageContentDiv = document.createElement("div");
            pageContentDiv.id = H5_element.ID.pageContentPane;
            document.body.appendChild(pageContentDiv);
            pageContentDiv.appendChild(pageContent);
            originalPageBlockWidth = $(".page-block").width();
            var widthScale = window.innerWidth * originalWidthScale / originalPageBlockWidth;
            if(widthScale > 1) {
                originalWidthScale = widthScale;
            }
            pageContentDiv.style.height = (window.innerHeight - toolbarHeight()) + "px";
            dealWithFrozen();
            if(h5_hasChart) {
                loadChart();
            }
            H5_element.hideParameterPane();
            addToolBar();
            //处理2个bug，x-table宽度比外层少1，会导致格子有背景色时，右边有白线；overflow visible是解决边框丢失。
            if(document.getElementsByClassName("x-table") != null && document.getElementsByClassName("x-table").length > 0) {
                document.getElementsByClassName("x-table")[0].style.overflow = "visible";
                document.getElementsByClassName("x-table")[0].style.width = "";
            }
        }
    }
}

//后台没有传递总页数，从pageContent里分析出总页数（醉了...），并且去掉用不到的js，判断是不是包含图表
function dealWithPageContent(pageContent) {
    var totalPageStart = "_p.reportTotalPage=";
    var index = pageContent.indexOf(totalPageStart);
    var strFromStart = pageContent.substring(index+totalPageStart.length);
    var end = strFromStart.indexOf(";");
    h5_totalPageNumber = strFromStart.substring(0, end);

    var pageBlockStart = "<div class=\"page-block\"";
    var lastDiv = "</div></div>"
    var htmlIndex = pageContent.indexOf(pageBlockStart);
    return pageContent.substring(htmlIndex, pageContent.length - lastDiv.length);
}

//加载图表需要的资源文件
function dealWithChartResource(pageContent) {
    h5_hasChart = (pageContent.indexOf('simplechart') >= 0);
    if(h5_hasChart) {
        if(!h5_hasFineReportJSLoaded) {
            h5_hasFineReportJSLoaded = loadJS(FR.servletURL + "?op=emb&resource=finereport.js");
        }
        if(!h5_hasChartJSLoaded) {
            h5_hasChartJSLoaded = loadJS(FR.servletURL + "?op=emb&resource=finereport.chart.js", FR.servletURL + "?op=resource&resource=com/fr/wei/plugin/h5report/js/weixin.handler.js");
               //重新定义超链函数
            reDefineDoHyperLink();
        }
        h5_hasChart = true;
    }
}

//加载JS文件
function loadJS() {
    var source = "";
    for(var i = 0, len = arguments.length; i < len; i ++) {
        var src = arguments[i];
        var result = false;
        var tempJQuery = jQuery;
        tempJQuery.ajax({
            url : src,
            dataType : "script", // alex:指定dataType为script,jquery会帮忙做globalEval的事情
            async : false,
            complete : function(res, status) {
                if (status == 'success') {
                    result = true;
                } else {
                    result = false;
                }
            }
        });
        return result;
    }
}

//加载图表，因为只支持分页，所以通过tds[i].hasAttribute("widget")判断是不是图表
function loadChart() {
    var tds = document.getElementsByTagName("td");
    for(var i = 0, len = tds.length; i < len; i ++) {
        if(tds[i].hasAttribute("widget")) {
            var chart = new FR.SimpleChart(FR.jsonDecode(tds[i].getAttribute("widget")));
            tds[i].appendChild(chart.element[0]);
        }
    }
}

//参数面板控件值
function collectValues(widgetNames) {
    var result = "";
    for(var i = 0, len = widgetNames.length; i < len; i ++) {
        var widgetName = widgetNames[i];
        if(widgetName) {
            var inputElement = document.getElementsByName(widgetName)[0];
            if(inputElement) {
                var value = inputElement.value;
                if(h5_isComboCheck(inputElement)) {
                    value = h5_getComboCheckValue(inputElement);
                }
                result += ("&" + FR.cjkEncode(widgetName) + "=" + FR.cjkEncode(value));
            }
        }
    }
    return result;
}

function h5_isComboCheck(element) {
    return (element.tagName.toUpperCase() == "SELECT" && element.getAttribute("multiple") == "multiple");
}

function h5_getComboCheckValue(element) {
    var selectedOptions = element.selectedOptions;
    var resultArray = [];
    for(var i = 0, len = selectedOptions.length; i < len; i ++) {
        resultArray[i] = selectedOptions[i].value;
    }
    return resultArray.join(",");
}

//是否需要工具栏
function needToolbar() {
    //如过没有参数面板，又只有一页就不显示工具栏了
    if(!h5_isShowParam && h5_totalPageNumber <= 1) {
        return false;
    }
    return true;
}

//toolbar高度
function toolbarHeight() {
    return needToolbar() ? 56 : 0;
}

function dealWithFrozen() {
    var pageContent = $(H5_element.getPageContentPane());
    var frozenPage = $(".frozen-page", pageContent);
    if(frozenPage.length > 0) {
        //有冻结
        pageContent.css({
            "-webkit-overflow-scrolling" : "auto",
            "overflow" : "hidden"
        });
        var $center = $('.frozen-center', frozenPage);
        var $corner = $('.frozen-corner', frozenPage);
        var $north = $('.frozen-north', frozenPage);
        var $west = $('.frozen-west', frozenPage);
        $west.css("overflow", "auto");
        resizeFrozenSize();
        $center[0].addEventListener("touchmove", function(e) {
            $north.scrollLeft($center.scrollLeft());
            $west.scrollTop($center.scrollTop());
        });
        $west[0].addEventListener("touchmove", function (e) {
            $center.scrollTop($west.scrollTop());
        });
    }
}

function addToolBar() {
    if(!needToolbar()) {
        return;
    }
    var toolBar = H5_element.getToolbarPane();
    if(toolBar == null) {
        toolBar = document.createElement("div");
        toolBar.id = H5_element.ID.toolbarPane;
        if(h5_isShowParam) {
            toolBar.appendChild(createFilterBtn());
        }
        toolBar.appendChild(createPreviousBtn());
        toolBar.appendChild(createNextBtn());
        toolBar.appendChild(createPageNumberBtn());
        document.body.appendChild(toolBar);
    }
    toolBar.removeAttribute("hidden");
}

//参数面板按钮
function createFilterBtn() {
    var filterBtn = document.createElement("div");
    filterBtn.id = H5_element.ID.filterButton;
    filterBtn.onclick = function() {
        H5_element.changeElementsAfterShowParameterPane();
        removeMenu();
        H5_element.removePageContentPane();
        H5_element.hideToolbarPane();
        H5_element.hideSliderWrap();
        H5_element.showParameterPane();
    }
    return filterBtn;
}

//前一页
function createPreviousBtn() {
    var wrap = document.createElement("div");
    wrap.className = "pagebtnwrap pagebtnwrap_previous";
    var previousBtn = document.createElement("div");
    previousBtn.id = "previous";
    wrap.onclick = function() {
        if(h5_currentPageIndex > 1) {
            removeMenu();
            H5_element.hideSliderWrap();
            loadReportOfPage(h5_currentPageIndex - 1, h5_sessionId);
        }
    }
    wrap.appendChild(previousBtn);
    return wrap;
}

//下一页
function createNextBtn() {
    var wrap = document.createElement("div");
    wrap.className = "pagebtnwrap pagebtnwrap_next";
    var nextBtn = document.createElement("div");
    nextBtn.id = "next";
    wrap.onclick = function() {
        removeMenu();
        var newIndex = parseInt(h5_currentPageIndex) + 1;
        if(newIndex <= h5_totalPageNumber) {
            H5_element.hideSliderWrap();
            loadReportOfPage(newIndex, h5_sessionId);
        }
    }
    wrap.appendChild(nextBtn);
    return wrap;
}

//页码
function createPageNumberBtn() {
    var pageBtn = document.createElement("div");
    pageBtn.id = "pagenumber";
    pageBtn.innerText = h5_currentPageIndex + "/" + h5_totalPageNumber;
    pageBtn.onclick = function() {
        removeMenu();
        var slider = H5_element.getSliderWrap();
        if(slider == null) {
            slider = createPageSlider();
            document.body.appendChild(slider);
        } else {
            var isHidden = slider.hasAttribute("hidden");
            if(isHidden) {
                slider.removeAttribute("hidden");
            } else {
                slider.setAttribute("hidden", "true");
            }
        }
        if(slider.circle != null) {
            slider.circle.style.left = circlePositions[h5_currentPageIndex - 1] + "px";
        }
    }
    return pageBtn;
}

function recalculateSliderPosition() {
    var totalWidth = window.innerWidth - 80;
    for(var i = 0; i < h5_totalPageNumber; i ++) {
        circlePositions[i] = totalWidth * (i / (h5_totalPageNumber - 1));
    }
}

var circlePositions = [];

//滑块控件
function createPageSlider() {
    var wrap = document.createElement("div");
    wrap.id = "sliderwrap";
    var container = document.createElement("div");
    container.id = "slidercontainer";
    wrap.appendChild(container);

    var slider_road = document.createElement("div");
    slider_road.id = "h5_slider_road"
    container.appendChild(slider_road);

    var slider_circle_wrap = document.createElement("div");
    slider_circle_wrap.id = "h5_slider_circle_wrap";


    var slider_circle = document.createElement("div");
    slider_circle.id = "h5_slider_circle";
    slider_circle_wrap.appendChild(slider_circle);

    slider_road.appendChild(slider_circle_wrap);

    var lastPageNumber = h5_currentPageIndex;
    var totalWidth = window.innerWidth - 80;
    for(var i = 0; i < h5_totalPageNumber; i ++) {
        circlePositions[i] = totalWidth * (i / (h5_totalPageNumber - 1));
    }
    var slider_touchMove = function(event) {
        event.preventDefault();
        if(!event.touches.length) {
            return;
        }
        var touch = event.touches[0];
        totalWidth = window.innerWidth - 80;
        if(touch.pageX - 40 >= totalWidth || touch.pageX - 40 <= 0) {
            return;
        }
        slider_circle_wrap.style.left = (touch.pageX - 40) + "px";
        var offset_X = (touch.pageX - 40) / totalWidth;
        lastPageNumber = Math.ceil(offset_X * h5_totalPageNumber);
        updatePage(lastPageNumber, false);
    }

    var slider_touchEnd = function(event) {
        slider_circle_wrap.style.left = circlePositions[lastPageNumber - 1] + "px";
        if(lastPageNumber != h5_currentPageIndex) {
            updatePage(lastPageNumber, true);
        }
    }

    slider_circle_wrap.addEventListener("touchmove", slider_touchMove, false);
    slider_circle_wrap.addEventListener("touchend", slider_touchEnd, false);
    wrap.circle = slider_circle_wrap;
    return wrap;
}

//滑块滑动时，更新页码上数据
function updatePage(pagenumber, loadReport) {
    if(loadReport) {
        loadReportOfPage(pagenumber, h5_sessionId);
        var slider = document.getElementById("sliderwrap");
        slider.setAttribute("hidden", "true");
    } else {
        document.getElementById("pagenumber").innerText = pagenumber + "/" + h5_totalPageNumber;
    }
}

//加载动画
function h5_addLoading() {
    h5_createTransparentMask();
    var loading = document.createElement("div");
    loading.id = "h5_loading";
    var mask = document.getElementById("h5_mask_transparent");
    mask.appendChild(loading);
}

function h5_removeLoading() {
    h5_removeMask();
    var loading = document.getElementById("h5_loading");
    if(loading != null) {
        h5_removeDom(loading);
    }
}

/**
 * FR
 */
if (window.FR == null) {
    window.FR = {};
}

function hyperLink(data) {
    new Function(unescape(data))();
}

function removeMenu() {
    var menuWrap = document.getElementById("menuWrap");
    if(menuWrap != null) {
        h5_removeDom(menuWrap);
    }
    h5_removeMask();
}


function createMenu(items) {
    removeMenu();
    var menuWrap = document.createElement("div");
    menuWrap.id = "menuWrap";
    menuWrap.style.height = 50 * (items.length + 1) + "px";
    menuWrap.style.width = window.innerWidth / 2;
    menuWrap.style.top = window.innerHeight / 2 - 25 * items.length + "px";
    menuWrap.style.left = window.innerWidth / 4 + "px";

    for(var i = 0, len = items.length; i < len; i ++) {
        (function(item) {
            var itemDiv = document.createElement("div");
            itemDiv.className = "menuItem";
            itemDiv.innerText = item.name;
            itemDiv.onclick = function() {
                removeMenu();
                hyperLink(item.data);
            }
            menuWrap.appendChild(itemDiv);
        })(items[i]);
    }
    var cancel = document.createElement("div");
    cancel.className = "menuItem";
    cancel.innerText = FR.i18nText("FS-Generic-Simple_Cancel");
    cancel.onclick = function() {
        removeMenu();
    }
    menuWrap.appendChild(cancel);
    document.body.appendChild(menuWrap);
    h5_createMask();
}

//创建遮罩
function h5_createMask() {
    var mask = document.createElement("div");
    mask.id = "h5_mask";
    document.body.appendChild(mask);
}

function h5_createTransparentMask() {
    var mask = document.createElement("div");
    mask.id = "h5_mask_transparent";
    document.body.appendChild(mask);
}

//去除遮罩
function h5_removeMask() {
    var mask = document.getElementById("h5_mask");
    if(mask != null) {
        h5_removeDom(mask);
    }
    var transparentMask = document.getElementById("h5_mask_transparent");
    if(transparentMask != null) {
        h5_removeDom(transparentMask);
    }
}

function reDefineDoHyperLink() {
    FR.doHyperlink = function(evt, obj, evtPosition) {
        if (obj instanceof Array) {
            switch (obj.length) {
                case 0:
                    return;
                case 1:
                    FR.doHyperlink(evt, obj[0]);
                    break;
                // alex:如果是数组,且长度只有1,不需要以弹出menu的方式处理超链
                default:
                    var _noMenuHyperlink =  function (data){
                        //目前只有图表块和报表块是需要直接联动
                        return data && (data.indexOf("chart_Change_Parameter") >= 0 ||
                            data.indexOf("_g().name_widgets[") >= 0);
                    }
                    // frank 图表关联时候不需要弹Menu,直接变化
                    var noMenuHyperlink = [];
                    var otherHyperlink = [];
                    for (var i = 0; i < obj.length; i++) {
                        var data = obj[i].data;
                        if (_noMenuHyperlink(data)) {
                            noMenuHyperlink[noMenuHyperlink.length] = obj[i];
                        } else {
                            otherHyperlink[otherHyperlink.length] = obj[i];
                        }
                    }

                    //for (var i = 0; i < noMenuHyperlink.length; i++) {
                    //    try{
                    //        hyperLink(noMenuHyperlink[i].data);
                    //    }catch(e){
                    //        FR.Msg.toast(e.message)
                    //        //do nth 某一个出错的, 不影响其他的
                    //    }
                    //}

                    switch (otherHyperlink.length) {
                        case 0:
                            return;
                        case 1:
                            FR.doHyperlink(evt, otherHyperlink[0]);
                            break;
                        default:
                            createMenu(otherHyperlink);
                    }
            }
        } else {
            hyperLink(obj.data);
        }
    }

    FR.doHyperlinkByGet4Reportlet = function(url, para, target, feature) {
        for(var key in para) {
            var pValue = para[key];
            if (key != "__LOCALE__" && key != "REPORTLET" && key != "OP" && (typeof pValue) != "object") {
                if (pValue instanceof Array) {
                    para[key] = pValue;
                } else {
                    para[key] = encodeURIComponent(encodeURIComponent(pValue));
                }
            }
        }
        var pString = "__parameters__=" + FR.cjkEncode(FR.jsonEncode(para));
        url += url.indexOf("?") == -1 ? "?" : "&";
        window.open(url + "op=h5_page&" + pString, target);
    }

    FR.doHyperlinkByGet = function(url, para, target, feature) {
        var pString = "";
        for(var key in para) {
            var pValue = para[key];
            if(pValue instanceof Array) {
                pValue = pValue.join(";");
            }
            var tmpName = FR.cjkDecode(key);
            var tmpValue = FR.cjkDecode(pValue);
            if (key != "__LOCALE__" && key != "REPORTLET" && key != "OP") {
                pString += "&" + encodeURIComponent(encodeURIComponent(tmpName)) + "=" + encodeURIComponent(encodeURIComponent(tmpValue));
            }
        }
        if(url.indexOf("reportlet=") >= 0) {
            pString += "&op=h5_page";
        }
        if (url.indexOf("?") == -1 && pString.length > 0) {
            url += "?";
            pString = pString.substring(1);
        }
        window.open(url + pString, target);
    }

    FR.doHyperlinkByPost = function(url, para, target, feature) {
        for(var pName in para) {
            var pValue = para[pName];
            if (pName != "__LOCALE__" && pName != "REPORTLET" && pName != "OP" && (typeof pValue) != "object") {
                if (pValue instanceof Array) {
                    para[pName] = pValue;
                } else {
                    para[pName] = encodeURIComponent(pValue);
                }
            }
        }
        if (this.$hyperlinkForm) {
            this.$hyperlinkForm.html("");
        } else {
            this.$hyperlinkForm = ($("<div>").appendTo($(document.body))).css({
                "display": "none",
                "position": "absolute"
            });
        }
        if (target == null) {
            target = "formresult";
        }
        para = FR.cjkEncode(FR.jsonEncode(para));
        var submitForm = $("<form method='post' target='" + target + "' action='" + url + "'></form>").appendTo(this.$hyperlinkForm);
        var input = $("<input type=\"hidden\" name=\"__parameters__\" value=\"\"/>");
        var input_h5 = $("<input type=\"hidden\" name=\"op\" value=\"h5_page\"/>");
        input.attr("value", para);
        submitForm.append(input);
        submitForm.append(input_h5);
        submitForm.submit();
    }
}

if(FR.tc == null) {
    FR.tc = function (fn, context) {
        try {
            return fn.call(context);
        } catch (e) {
            throw e;
        }
    }
}

if(FR.cjkEncode == null) {
    //中文加密
    FR.cjkEncode = function(text) {
        // alex:如果非字符串,返回其本身(cjkEncode(234) 返回 ""是不对的)
        if (typeof text !== 'string') {
            return text;
        }

        var newText = "";
        for (var i = 0; i < text.length; i++) {
            var code = text.charCodeAt(i);
            if (code >= 128 || code === 91 || code === 93) {//91 is "[", 93 is "]".
                newText += "[" + code.toString(16) + "]";
            } else {
                newText += text.charAt(i);
            }
        }

        return newText
    };
}

if(FR.cjkDecode == null) {
    //中文解密
    FR.cjkDecode = function(text) {
        if (text == null) {
            return "";
        }
        //查找没有 "[", 直接返回.  kunsnat:数字的时候, 不支持indexOf方法, 也是直接返回.
        if (!isNaN(text) || text.indexOf('[') == -1) {
            return text;
        }

        var newText = "";
        for (var i = 0; i < text.length; i++) {
            var ch = text.charAt(i);
            if (ch == '[') {
                var rightIdx = text.indexOf(']', i + 1);
                if (rightIdx > i + 1) {
                    var subText = text.substring(i + 1, rightIdx);
                    //james：主要是考虑[CDATA[]]这样的值的出现
                    if (subText.length > 0) {
                        ch = String.fromCharCode(eval("0x" + subText));
                    }

                    i = rightIdx;
                }
            }

            newText += ch;
        }

        return newText;
    }
}

if(FR.jsonEncode == null) {
    //json encode
    FR.jsonEncode = function(o) {
        //james:这个Encode是抄的EXT的
        var useHasOwn = {}.hasOwnProperty ? true : false;

        // crashes Safari in some instances
        //var validRE = /^("(\\.|[^"\\\n\r])*?"|[,:{}\[\]0-9.\-+Eaeflnr-u \n\r\t])+?$/;

        var m = {
            "\b": '\\b',
            "\t": '\\t',
            "\n": '\\n',
            "\f": '\\f',
            "\r": '\\r',
            '"': '\\"',
            "\\": '\\\\'
        };

        var encodeString = function (s) {
            if (/["\\\x00-\x1f]/.test(s)) {
                return '"' + s.replace(/([\x00-\x1f\\"])/g, function (a, b) {
                        var c = m[b];
                        if (c) {
                            return c;
                        }
                        c = b.charCodeAt();
                        return "\\u00" +
                            Math.floor(c / 16).toString(16) +
                            (c % 16).toString(16);
                    }) + '"';
            }
            return '"' + s + '"';
        };

        var encodeArray = function (o) {
            var a = ["["], b, i, l = o.length, v;
            for (i = 0; i < l; i += 1) {
                v = o[i];
                switch (typeof v) {
                    case "undefined":
                    case "function":
                    case "unknown":
                        break;
                    default:
                        if (b) {
                            a.push(',');
                        }
                        a.push(v === null ? "null" : FR.jsonEncode(v));
                        b = true;
                }
            }
            a.push("]");
            return a.join("");
        };

        if (typeof o == "undefined" || o === null) {
            return "null";
        } else if (o instanceof Array) {
            return encodeArray(o);
        } else if (o instanceof Date) {
            /*
             * alex:原来只是把年月日时分秒简单地拼成一个String,无法decode
             * 现在这么处理就可以decode了,但是JS.jsonDecode和Java.JSONObject也要跟着改一下
             */
            return FR.jsonEncode({
                __time__: o.getTime()
            })
        } else if (typeof o == "string") {
            return encodeString(o);
        } else if (typeof o == "number") {
            return isFinite(o) ? String(o) : "null";
        } else if (typeof o == "boolean") {
            return String(o);
        } else if ((typeof o) == "function") {
            return String(o);
        } else {
            var a = ["{"], b, i, v;
            for (i in o) {
                if (!useHasOwn || o.hasOwnProperty(i)) {
                    v = o[i];
                    switch (typeof v) {
                        case "undefined":
                        case "unknown":
                            break;
                        default:
                            if (b) {
                                a.push(',');
                            }
                            a.push(FR.jsonEncode(i), ":",
                                v === null ? "null" : FR.jsonEncode(v));
                            b = true;
                    }
                }
            }
            a.push("}");
            return a.join("");
        }
    };
}